summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorTim Rühsen <tim.ruehsen@gmx.de>2019-02-18 21:38:38 +0100
committerTim Rühsen <tim.ruehsen@gmx.de>2019-02-18 21:41:10 +0100
commite6d9cb28fc1d82e97b9f65cde8e642645d6e9ed5 (patch)
treebab1fd76a49088faa886642eca2fee6c97e325f8
parent34988aa20369cb71e59b94772132b5efab6bc076 (diff)
downloadgnutls-tmp-fix-cli-starttls-xmpp.tar.gz
Add test for starttls XMPPtmp-fix-cli-starttls-xmpp
Signed-off-by: Tim Rühsen <tim.ruehsen@gmx.de>
-rw-r--r--tests/Makefile.am4
-rwxr-xr-xtests/starttls-xmpp.sh46
-rw-r--r--tests/starttls-xmpp.txt3
3 files changed, 51 insertions, 2 deletions
diff --git a/tests/Makefile.am b/tests/Makefile.am
index 0c433b0370..f9533c256b 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -41,7 +41,7 @@ EXTRA_DIST = suppressions.valgrind eagain-common.h cert-common.h test-chains.h \
certs/ed25519.pem certs/cert-ed25519.pem \
system.prio pkcs11/softhsm.h pkcs11/pkcs11-pubkey-import.c gnutls-asan.supp \
rsa-md5-collision/README safe-renegotiation/README starttls-smtp.txt starttls-ftp.txt \
- starttls-lmtp.txt starttls-pop3.txt starttls-nntp.txt starttls-sieve.txt \
+ starttls-lmtp.txt starttls-pop3.txt starttls-xmpp.txt starttls-nntp.txt starttls-sieve.txt \
rsa-md5-collision/colliding-chain-md5-2.pem rsa-md5-collision/colliding-chain-md5-1.pem \
ocsp-tests/certs/ocsp-amazon.com.der ocsp-tests/certs/chain-amazon.com.pem \
ocsp-tests/certs/chain-amazon.com-unsorted.pem cipher-neg-common.c \
@@ -461,7 +461,7 @@ dtls_stress_LDADD = $(COMMON_GNUTLS_LDADD) \
$(COMMON_DEPS_LDADD)
dist_check_SCRIPTS += fastopen.sh pkgconfig.sh starttls.sh starttls-ftp.sh starttls-smtp.sh \
- starttls-lmtp.sh starttls-pop3.sh starttls-nntp.sh starttls-sieve.sh \
+ starttls-lmtp.sh starttls-pop3.sh starttls-xmpp.sh starttls-nntp.sh starttls-sieve.sh \
ocsp-tests/ocsp-tls-connection ocsp-tests/ocsp-must-staple-connection \
ocsp-tests/ocsp-test cipher-listings.sh sni-hostname.sh server-multi-keys.sh \
psktool.sh ocsp-tests/ocsp-load-chain gnutls-cli-save-data.sh gnutls-cli-debug.sh \
diff --git a/tests/starttls-xmpp.sh b/tests/starttls-xmpp.sh
new file mode 100755
index 0000000000..71fc512572
--- /dev/null
+++ b/tests/starttls-xmpp.sh
@@ -0,0 +1,46 @@
+#!/bin/sh
+
+# Copyright (C) 2010-2016 Free Software Foundation, Inc.
+#
+# Author: Nikos Mavrogiannopoulos
+#
+# This file is part of GnuTLS.
+#
+# GnuTLS is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by the
+# Free Software Foundation; either version 3 of the License, or (at
+# your option) any later version.
+#
+# GnuTLS is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with GnuTLS; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
+
+srcdir="${srcdir:-.}"
+SERV="${SERV:-../src/gnutls-serv${EXEEXT}}"
+CLI="${CLI:-../src/gnutls-cli${EXEEXT}}"
+unset RETCODE
+
+. "${srcdir}/scripts/common.sh"
+. "${srcdir}/scripts/starttls-common.sh"
+
+echo "Checking STARTTLS over XMPP"
+
+eval "${GETPORT}"
+socat TCP-LISTEN:${PORT} EXEC:"$CHAT -e -S -v -f ${srcdir}/starttls-xmpp.txt",pty &
+PID=$!
+wait_server ${PID}
+
+${VALGRIND} "${CLI}" -p "${PORT}" 127.0.0.1 --priority NORMAL:+ANON-ECDH --insecure --starttls-proto xmpp --verbose </dev/null >/dev/null
+if test $? != 1;then
+ fail ${PID} "connect should have failed with error code 1"
+fi
+
+kill ${PID}
+wait
+
+exit 0
diff --git a/tests/starttls-xmpp.txt b/tests/starttls-xmpp.txt
new file mode 100644
index 0000000000..94e86d48e1
--- /dev/null
+++ b/tests/starttls-xmpp.txt
@@ -0,0 +1,3 @@
+TIMEOUT 10
+'<stream:stream xmlns:stream' '<?xml version\=\'1.0\'?><stream:stream id\=\'16633990255660214772\' version\=\'1.0\' xml:lang\=\'en\' xmlns:stream\=\'http://etherx.jabber.org/streams\' from\=\'schokokeks.org\' xmlns\=\'jabber:client\'><stream:features><starttls xmlns\=\'urn:ietf:params:xml:ns:xmpp-tls\'><required/></starttls></stream:features>'
+'<starttls xmlns\=\'urn:ietf:params:xml:ns:xmpp-tls\'/>' '<proceed xmlns\=\'urn:ietf:params:xml:ns:xmpp-tls\'/>'